// Generated with EntitiesToDTOs.v2.1 (entitiestodtos.codeplex.com).
// Timestamp: 24/10/2012 - 14:22:19
using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Text;
using System.Linq;

namespace UnboundColumnUpdatingHierarchy.Models
{

    /// <summary>
    /// Assembler for <see cref="EmployeeDepartmentHistory"/> and <see cref="EmployeeDepartmentHistoryDTO"/>.
    /// </summary>
    public static partial class EmployeeDepartmentHistoryAssembler
    {
        /// <summary>
        /// Invoked when <see cref="ToDTO"/> operation is about to return.
        /// </summary>
        /// <param name="dto"><see cref="EmployeeDepartmentHistoryDTO"/> converted from <see cref="EmployeeDepartmentHistory"/>.</param>
        static partial void OnDTO(this EmployeeDepartmentHistory entity, EmployeeDepartmentHistoryDTO dto);

        /// <summary>
        /// Invoked when <see cref="ToEntity"/> operation is about to return.
        /// </summary>
        /// <param name="entity"><see cref="EmployeeDepartmentHistory"/> converted from <see cref="EmployeeDepartmentHistoryDTO"/>.</param>
        static partial void OnEntity(this EmployeeDepartmentHistoryDTO dto, EmployeeDepartmentHistory entity);

        /// <summary>
        /// Converts this instance of <see cref="EmployeeDepartmentHistoryDTO"/> to an instance of <see cref="EmployeeDepartmentHistory"/>.
        /// </summary>
        /// <param name="dto"><see cref="EmployeeDepartmentHistoryDTO"/> to convert.</param>
        public static EmployeeDepartmentHistory ToEntity(this EmployeeDepartmentHistoryDTO dto)
        {
            if (dto == null) return null;

            EmployeeDepartmentHistory entity = null;

            entity = new EmployeeDepartmentHistory();

            entity.BusinessEntityID = dto.BusinessEntityID;
            entity.DepartmentID = dto.DepartmentID;
            entity.ShiftID = dto.ShiftID;
            entity.StartDate = dto.StartDate;
            entity.EndDate = dto.EndDate;
            entity.ModifiedDate = dto.ModifiedDate;

            dto.OnEntity(entity);

            return entity;
        }

        /// <summary>
        /// Converts this instance of <see cref="EmployeeDepartmentHistory"/> to an instance of <see cref="EmployeeDepartmentHistoryDTO"/>.
        /// </summary>
        /// <param name="entity"><see cref="EmployeeDepartmentHistory"/> to convert.</param>
        public static EmployeeDepartmentHistoryDTO ToDTO(this EmployeeDepartmentHistory entity)
        {
            if (entity == null) return null;

            EmployeeDepartmentHistoryDTO dto = null;

            dto = new EmployeeDepartmentHistoryDTO();

            dto.BusinessEntityID = entity.BusinessEntityID;
            dto.DepartmentID = entity.DepartmentID;
            dto.ShiftID = entity.ShiftID;
            dto.StartDate = entity.StartDate;
            dto.EndDate = entity.EndDate;
            dto.ModifiedDate = entity.ModifiedDate;
            dto.Department_DepartmentID = entity.Department.DepartmentID;
            dto.Employee_BusinessEntityID = entity.Employee.BusinessEntityID;

            entity.OnDTO(dto);

            return dto;
        }
    }
}
